Attribute VB_Name = "NtDll"
'DDK-Deklarationen
Public Declare Function NtQueryInformationProcess Lib "NTDLL.DLL" (ByVal hProc&, ByVal EnumValue As Any, ProcessOut As Any, ByVal ProcessInformationLength&, ReturnLength&) As Long

Public Type PROCESS_WS_WATCH_INFORMATION
  FaultingPc As Long
  FaultingVa As Long
End Type

Public Type PROCESS_BASIC_INFORMATION
  ExitStatus As Long
  PebBaseAdress As Long
  AffinityMask As Long
  BasePriority As Long
  UniqueProcessId As Long
  InheritedFromUniqueProcessId As Long
End Type

Public Type QUOTA_LIMITS
  PagedPoolLimit As Long
  NonPagedPoolLimit As Long
  MinimumWorkingSetSize As Long
  MaximumWorkingSetSize As Long
  PagefileLimit As Long
  TimeLimit As String * 8
End Type

Public Type IO_COUNTERS
  ReadOperationCount As Long
  WriteOperationCount As Long
  OtherOperationCount As Long
  ReadTransferCount As Long
  WriteTransferCount As Long
  OtherTransferCount As Long
End Type

Public Type VM_COUNTERS
  PeakVirtualSize As Long
  VirtualSize As Long
  PageFaultCount As Long
  PeakWorkingSetSize As Long
  WorkingSetSize As Long
  QuotaPeakPagedPoolUsage As Long
  QuotaPagedPoolUsage As Long
  QuotaPeakNonPagedPoolUsage As Long
  QuotaNonPagedPoolUsage As Long
  PagefileUsage As Long
  PeakPagefileUsage As Long
End Type

Public Type POOLED_USAGE_AND_LIMITS
  PeakPagedPoolUsage As Long
  PagedPoolUsage As Long
  PagedPoolLimit As Long
  PeakNonPagedPoolUsage As Long
  NonPagedPoolUsage As Long
  NonPagePoolLimit As Long
  PeakPagefileUsage As Long
  PagefileUsage As Long
  PagefileLimit As Long
End Type

Public Type KERNEL_USER_TIMES
  CreateTime As Long
  ExitTime As Long
  KernelTime As Long
  UserTime As Long
End Type

Public Type PROCESS_ACCESS_TOKEN
  Token As Long
  Thread As Long
End Type

Public Enum PROCESSINFOCLASS
  'Enumeration der abrufbaren Teilinformationen
  ProcessBasicInformation
  ProcessQuotaLimits
  ProcessIoCounters
  ProcessVmCounters
  ProcessTimes
  ProcessBasePriority
  ProcessRaisePriority
  ProcessDebugPort
  ProcessExceptionPort
  ProcessAccessToken
  ProcessLdtInformation
  ProcessLdtSize
  ProcessDefaultHardErrorMode
  ProcessIoPortHandlers
  ProcessPooledUsageAndLimits
  ProcessWorkingSetWatch
  ProcessUserModeIOPL
  ProcessEnableAlignmentFaultFixup
  ProcessPriorityClass
  ProcessWx86Information
  ProcessHandleCount
  ProcessAffinityMask
  ProcessPriorityBoost
  MaxProcessInfoClass
End Enum

